/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Centro Integrado de Tecnologia da Informao - CITi
 * Curso de C/C++
 * Autor: Allan Lima - http://allanlima.wordpress.com/
 * Instrutor: Luiz Felipe Sotero (lfss@cin.ufpe.br)
 *
 * exemploTemplatesClasse.cpp - Mostra implementar templates de classes.
 */

#include <iostream>

using namespace std;
/*
template <class T>
class Stack {
private:
	T *elements; // os elementos da pilha
	int nextIndex; // o prximo ndice vazio no array de elementos
	int size; // a capacidade mxima da pilha

public:
	// construtor: aloca espao para size elementos
	Stack(int size);

	// insere element no topo da pilha
	void push(T &element);

	// remove o primeiro elemento da pilha , ou seja,  o seu topo
	T pop();

	// retorna true se a pilha esta vazia ou false caso contrrio
	bool isEmpty(){ return this->nextIndex == 0; }

	// destrutor: libera a memria alocada pelo construtor
	~Stack();
};

//Construtor genrico
template <class T>
Stack<T>::Stack(int size) {
	this->size = size;
	this->elements = new T[size];
	this->nextIndex = size - 1;
}

//Insero na pilha
template <class T>
void Stack<T>::push(T &element) {
	if (this->nextIndex != -1) {
		this->elements[this->nextIndex] = element;
		this->nextIndex--;
	}
}

template <class T>
T Stack<T>::pop() {
	T ret;
	if (this->nextIndex < (this->size - 1)) {
		ret = elements[this->nextIndex+1];
        this->nextIndex++;
	}

	return ret;
}

template <class T>
Stack<T>::~Stack() {
	delete [] this->elements;
}

int main() {
    //Cria uma stack de 10 inteiros;
	Stack<int> stackInt(10);

	for (int i = 0; i < 10; i++) {
		stackInt.push(i);
	}

	for (int i = 0; i < 10; i++) {
		cout << stackInt.pop() << endl;
	}

	Stack<double> stackDouble(10);
	double base = 5.50;

	for (int i = 0; i < 10; i++) {
		stackDouble.push(base);
		base = base + 10.0;
	}

	for (int i = 0; i < 10; i++) {
		cout << stackDouble.pop() << endl;
	}


	return 0;
}*/
