/*
 * Universidade Federal de Pernambuco - UFPE
 * Centro de Informtica - CIn
 * Centro Integrado de Tecnologia da Informao - CITi
 * Curso de C/C++
 * Autor: Allan Lima - http://allanlima.wordpress.com/
 * Instrutor: Luiz Felipe Sotero (lfss@cin.ufpe.br)
 *
 * exemploEspecializacaoTemplatesMetodos.cpp - Mostra como especializar
 *                                             mtodos de classes templates
 *
 */

#include <iostream>
#include <cstring>

using namespace std;
/*
template <class T>
class Stack {
private:
	T *elements; // os elementos da pilha
	int nextIndex; // o prximo ndice vazio no array de elementos
	int size; // a capacidade mxima da pilha

public:
	// contrutor: aloca espao para size elementos
	Stack(int size);

	// insere element no topo da pilha
	void push(T &element);

	// remove o primeiro elemento da pilha , ou seja,  o seu topo
	T pop();

	// retora true se a plilha esta vazia ou false caso contrrio
	bool isEmpty(){ return this->nextIndex == 0; };

	// destrutor: libera a memria alocada pelo construtor
	~Stack();
};

template <class T>
Stack<T>::Stack(int size) {
	this->size = size;
	this->elements = new T[size];
	this->nextIndex = 0;
}

template <class T>
void Stack<T>::push(T &element) {
	if (this->nextIndex != this->size) {
		this->elements[this->nextIndex] = element;
		this->nextIndex++;
	}
}

// no precisamos mais do template <class T>
void Stack<char*>::push(char* &element) {
	if (this->nextIndex != this->size) {
		this->elements[this->nextIndex] = new char[strlen(element) + 1];
		strcpy(this->elements[this->nextIndex], element);
		this->nextIndex++;
    }
}


template <class T>
T Stack<T>::pop() {
	T ret;
	if (this->nextIndex > 0) {
		this->nextIndex--;
		ret = elements[this->nextIndex];
	}

	return ret;
}

template <class T>
Stack<T>::~Stack() {
	delete [] this->elements;
}

int main() {
	Stack<int> sInt(10);

	for (int i = 0; i < 10; i++) {
		sInt.push(i);
	}

	for (int i = 0; i < 10; i++) {
		cout << sInt.pop() << endl;
	}

	Stack<double> sDouble(10);
	double base = 5.50;

	for (int i = 0; i < 10; i++) {
		sDouble.push(base);
		base = base + 10.0;
	}

	for (int i = 0; i < 10; i++) {
		cout << sDouble.pop() << endl;
	}

	Stack<char *> sChar(10);
	char *string = new char[50];
	strcpy(string, "CIn");
	sChar.push(string);
	strcpy(string, "UFPE");
	sChar.push(string);
	strcpy(string, "C++");
	sChar.push(string);

	while (!sChar.isEmpty()) {
		char *element = sChar.pop();
		cout << element << endl;
		delete [] element;
	}


	return 0;
}	*/
